'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _props = require('./props');

var _reactDom = require('react-dom');

var _reactDom2 = _interopRequireDefault(_reactDom);

var _blur = require('./utils/blur');

var _blur2 = _interopRequireDefault(_blur);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var UniversalImage = function (_Component) {
  _inherits(UniversalImage, _Component);

  function UniversalImage() {
    var _ref;

    var _temp, _this, _ret;

    _classCallCheck(this, UniversalImage);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_ref = UniversalImage.__proto__ || Object.getPrototypeOf(UniversalImage)).call.apply(_ref, [this].concat(args))), _this), _this.initComponent = function (props) {
      if (typeof props === 'undefined') {
        props = _this.props;
      }

      var ratio = props.ratio > 0 ? props.ratio : 0;
      if (ratio === 0 && props.width && props.height && parseInt(props.width) > 0 && parseInt(props.height) > 0) {
        ratio = parseInt(props.width) / parseInt(props.height);
      }

      _this.setState({
        status: props.lazy ? 'waiting' : 'loading', // waiting, loading, animation, done
        ratio: ratio,
        ratioAuto: false, // if ratio was calculated automatically
        ignoreTransition: false
      });

      if (_this._timers) {
        for (var key in _this._timers) {
          if (_this._timers.hasOwnProperty(key)) {
            clearTimeout(_this._timers[key]);
          }
        }
      }
      _this._timers = {};

      _this.scrollWait = false;
      _this._createdAt = new Date().getTime();
    }, _this.allListeners = function () {
      if (_this.props.lazy) {
        _this._scrollListener = _this.scrollListener.bind(_this);
        var passiveSupported = false;

        try {
          var options = Object.defineProperty({}, 'passive', {
            get: function get() {
              passiveSupported = true;
            }
          });

          window.addEventListener('test', null, options);
        } catch (err) {}
        window.addEventListener('scroll', _this._scrollListener, passiveSupported ? { passive: true } : false);
        window.addEventListener('wheel', _this._scrollListener, passiveSupported ? { passive: true } : false);
        _this.checkVisibility();
      }
    }, _this.removeListeners = function () {
      if (typeof _this._scrollListener === 'function') {
        window.removeEventListener('scroll', _this._scrollListener, false);
        window.removeEventListener('wheel', _this._scrollListener, false);
        _this._scrollListener = null;
      }
    }, _this.scrollListener = function () {
      if (!_this.scrollWait) {
        _this.scrollWait = true;

        _this.checkVisibility();

        _this._timers.scroll = setTimeout(function () {
          _this.scrollWait = false;
        }, _this.props.debounce);
      }
    }, _temp), _possibleConstructorReturn(_this, _ret);
  }

  _createClass(UniversalImage, [{
    key: 'componentWillMount',
    value: function componentWillMount() {
      this.initComponent();
    }
  }, {
    key: 'componentDidMount',
    value: function componentDidMount() {
      this.allListeners();
    }
  }, {
    key: 'componentWillReceiveProps',
    value: function componentWillReceiveProps(nextProps) {
      if (nextProps.src !== this.props.src || nextProps.srcSet !== this.props.srcSet) {
        this.initComponent(nextProps);
      }
    }
  }, {
    key: 'componentWillUpdate',
    value: function componentWillUpdate(nextProps, nextState) {}
  }, {
    key: 'componentDidUpdate',
    value: function componentDidUpdate(prevProps, prevState) {
      // components src was changed
      if (this.state.status === 'waiting' && prevState.status !== this.state.status) {
        if (this._scrollListener === null) {
          this.allListeners();
        }
      }
    }
  }, {
    key: 'componentWillUnmount',
    value: function componentWillUnmount() {
      this.removeListeners();
      if (this._timers) {
        for (var key in this._timers) {
          if (this._timers.hasOwnProperty(key)) {
            clearTimeout(this._timers[key]);
          }
        }
      }
    }
  }, {
    key: 'getNode',
    value: function getNode() {
      if (!this._node) {
        this._node = _reactDom2['default'].findDOMNode(this);
      }
      return this._node;
    }
  }, {
    key: 'isVisible',
    value: function isVisible() {
      var scrollTop = UniversalImage.getScrollTop();

      var rect = this.getNode().getBoundingClientRect();

      var elementTop = rect.top + scrollTop;
      var elementBottom = elementTop + rect.height;

      var documentBottom = scrollTop + UniversalImage.getWindowHeight();

      return elementTop <= documentBottom && elementBottom >= scrollTop;
    }
  }, {
    key: 'checkVisibility',
    value: function checkVisibility() {
      if (this.state.status === 'waiting' && this.isVisible()) {
        this.setState({
          status: 'loading'
        });
        this.removeListeners();
      }
    }
  }, {
    key: 'renderFillBox',
    value: function renderFillBox() {
      var padding = this.state.ratio > 0 ? 1 / this.state.ratio * 100 : 50;
      var style = _extends({}, styles.block, { paddingBottom: padding + '%' });
      return _react2['default'].createElement('span', { style: style });
    }
  }, {
    key: 'onPlaceHolderLoad',
    value: function onPlaceHolderLoad() {
      var _this2 = this;

      var thumbnail = this.getNode().getElementsByTagName('img')[0];

      if (!(thumbnail.naturalHeight > 0)) {
        return;
      }

      if (this.props.blur > 0) {
        var canvas = this.getNode().getElementsByTagName('canvas')[0];
        if (canvas && thumbnail) {
          canvas.width = 60;
          canvas.height = Math.max(10, Math.round(60 / (thumbnail.naturalWidth / thumbnail.naturalHeight)));

          if (typeof window !== 'undefined') {
            var cacheKey = this.props.placeholder.length > 60 ? this.props.src : this.props.placeholder;

            if (typeof window.universalImageCache === 'undefined') {
              window.universalImageCache = {};
            }

            if (typeof window.universalImageCache[cacheKey] === 'undefined') {
              canvas.getContext('2d').drawImage(thumbnail, 0, 0, canvas.width, canvas.height);
              (0, _blur2['default'])(canvas, this.props.blur);
              window.universalImageCache[cacheKey] = canvas.toDataURL('image/jpeg');
            } else {
              // get blured image from cache
              // eslint-disable-next-line no-undef
              this._blureCache = new Image();
              this._blureCache.onload = function () {
                if (_this2._blureCache) {
                  canvas.getContext('2d').drawImage(_this2._blureCache, 0, 0, canvas.width, canvas.height);
                }
              };
              this._blureCache.src = window.universalImageCache[cacheKey];
            }
          } else {
            canvas.getContext('2d').drawImage(thumbnail, 0, 0, canvas.width, canvas.height);
            (0, _blur2['default'])(canvas, this.props.blur);
          }
        }
      }

      if (this.state.ratio === 0) {
        // get ratio from placeholder
        this.setState({
          ratio: thumbnail.naturalWidth / thumbnail.naturalHeight,
          ratioAuto: true
        });
      }
    }
  }, {
    key: 'onImageLoad',
    value: function onImageLoad() {
      var _this3 = this;

      var newState = {};

      if (this.state.ratio === 0 || this.state.ratioAuto) {
        var images = this.getNode().getElementsByTagName('img');
        var image = images[images.length - 1];
        // get ratio from image
        newState.ratio = image.naturalWidth / image.naturalHeight;
        newState.ratioAuto = true;
      }

      if (this.props.animationSpeed === 0 || this.props.skipAnimation > 0 && new Date().getTime() < this._createdAt + this.props.skipAnimation) {
        newState.status = 'done';
        newState.ignoreTransition = true;
      } else {
        newState.status = 'animation';

        this._timers.done = setTimeout(function () {
          _this3.setState({
            status: 'done'
          });
        }, this.props.animationSpeed + 100); // + 100ms in case of lags
      }

      this.setState(newState);
    }
  }, {
    key: 'onImageError',
    value: function onImageError() {
      this.setState({
        status: 'error'
      });
    }
  }, {
    key: 'renderPlaceholder',
    value: function renderPlaceholder() {
      var _this4 = this;

      var placeholder = this.props.placeholder;

      if (this.state.status === 'done' || typeof placeholder === 'undefined' || this.state.status === 'error' && typeof this.props.fallback === 'string') {
        return null;
      }

      var style = _extends({}, styles.full, { zIndex: 1 });

      if (typeof placeholder === 'string') {
        var allowedAttributes = ['alt', 'crossOrigin'];
        var attributes = {};
        allowedAttributes.forEach(function (attribute) {
          if (typeof _this4.props[attribute] !== 'undefined') {
            attributes[attribute] = _this4.props[attribute];
          }
        });

        attributes.onLoad = function () {
          _this4.onPlaceHolderLoad();
        };

        attributes.src = placeholder;

        if (this.props.blur > 0) {
          attributes.style = { display: 'none' };
          return [_react2['default'].createElement('img', _extends({ key: 1 }, attributes)), _react2['default'].createElement('canvas', { key: 2, style: style })];
        } else {
          attributes.style = style;
          return _react2['default'].createElement('img', attributes);
        }
      } else {
        return _react2['default'].createElement(
          'span',
          { style: style },
          placeholder
        );
      }
    }
  }, {
    key: 'renderImage',
    value: function renderImage() {
      var _this5 = this;

      if (this.state.status === 'waiting') {
        return null;
      }

      if (this.state.status === 'error') {
        if (typeof this.props.fallback === 'string') {
          var backgroundStyle = {
            backgroundImage: 'url(' + this.props.fallback + ')',
            backgroundRepeat: 'no-repeat',
            backgroundPosition: 'center center'
          };
          var _style = _extends({}, styles.full, { zIndex: 2 }, backgroundStyle);
          return _react2['default'].createElement('span', { className: 'img-fallback', style: _style });
        } else {
          return null;
        }
      }

      var transition = this.state.ignoreTransition ? {} : {
        transition: 'visibility 0s linear 0s, opacity ' + this.props.animationSpeed / 1000 + 's 0s'
      };

      var style = _extends({}, styles.full, { transition: transition, zIndex: 2 });

      if (this.state.status === 'done' || this.state.status === 'animation') {
        style = _extends({}, style, styles.visible);
      } else {
        style = _extends({}, style, styles.hidden);
      }

      var allowedAttributes = ['src', 'srcSet', 'sizes', 'alt', 'crossOrigin'];
      var attributes = {};
      allowedAttributes.forEach(function (attribute) {
        if (typeof _this5.props[attribute] !== 'undefined') {
          attributes[attribute] = _this5.props[attribute];
        }
      });

      attributes.onLoad = function () {
        _this5._timers.onImageLoadTimeout = setTimeout(function () {
          _this5.onImageLoad();
        }, 100);
      };

      attributes.onError = function () {
        _this5.onImageError();
      };

      attributes.style = style;

      return _react2['default'].createElement('img', attributes);
    }
  }, {
    key: 'getWrapperProps',
    value: function getWrapperProps() {
      var props = {};

      props.style = _extends({}, styles.block);

      if (this.props.inline) {
        props.style = _extends({}, props.style, styles.inline);
      }

      if (this.props.maxWidth) {
        if (typeof this.props.maxWidth === 'number' || /^\d+$/.test(this.props.maxWidth)) {
          props.style.maxWidth = this.props.maxWidth + 'px';
        } else {
          props.style.maxWidth = this.props.maxWidth;
        }
      }

      if (this.props.className) {
        props.className = this.props.className;
      }

      if (this.props.id) {
        props.id = this.props.id;
      }

      return props;
    }
  }, {
    key: 'render',
    value: function render() {
      return _react2['default'].createElement(
        'span',
        this.getWrapperProps(),
        this.renderFillBox(),
        this.renderPlaceholder(),
        this.renderImage()
      );
    }
  }], [{
    key: 'getWindowHeight',
    value: function getWindowHeight() {
      return window.innerHeight || document.documentElement.clientHeight || document.body.clientHeight;
    }
  }, {
    key: 'getScrollTop',
    value: function getScrollTop() {
      var isCSS1Compat = (document.compatMode || '') === 'CSS1Compat';
      return typeof window.pageXOffset !== 'undefined' ? window.pageYOffset : isCSS1Compat ? document.documentElement.scrollTop : document.body.scrollTop;
    }
  }]);

  return UniversalImage;
}(_react.Component);

UniversalImage.displayName = 'UniversalImage';
UniversalImage.propTypes = _props.propTypes;
UniversalImage.defaultProps = _props.defaultProps;
exports['default'] = UniversalImage;


var styles = {
  block: {
    display: 'block',
    padding: 0,
    position: 'relative',
    zIndex: 0
  },
  full: {
    position: 'absolute',
    display: 'block',
    left: 0,
    top: 0,
    bottom: 0,
    right: 0,
    margin: 0,
    padding: 0,
    width: '100%',
    maxWidth: '100%',
    height: '100%'
  },
  hidden: {
    visibility: 'hidden',
    opacity: 0
  },
  visible: {
    visibility: 'visible',
    opacity: 1
  },
  inline: {
    display: 'inline-block',
    width: '100%'
  }
};