'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.DEPRECATED_CONFIG_PROPS = exports.defaultProps = exports.propTypes = undefined;

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

var string = _propTypes2['default'].string,
    bool = _propTypes2['default'].bool,
    number = _propTypes2['default'].number,
    oneOfType = _propTypes2['default'].oneOfType,
    node = _propTypes2['default'].node;
var propTypes = exports.propTypes = {
  id: string,
  className: string,
  crossOrigin: string,
  src: string,
  srcSet: string,
  placeholder: oneOfType([string, node]),
  fallback: string,
  'blur': number,
  ratio: number,
  debounce: number,
  animationSpeed: number,
  maxWidth: oneOfType([number, string]),
  alt: string,
  sizes: string,
  skipAnimation: number,
  inline: bool
};

var defaultProps = exports.defaultProps = {
  alt: '',
  debounce: 200,
  animationSpeed: 400,
  inline: false,
  'blur': 3,
  lazy: true,
  skipAnimation: 0
};

var DEPRECATED_CONFIG_PROPS = exports.DEPRECATED_CONFIG_PROPS = ['old-alt'];