import path from 'path'
import config, { minifyPlugins } from './webpack.demo.babel'

export default {
  ...config,
  entry: './src/Image',
  output: {
    path: path.join(__dirname, 'dist'),
    filename: 'Image.js',
    library: 'UniversalImage'
  },
  externals: {
    'react': 'React'
  },
  module: {
    rules: [
      {
        test: /\.js$/,
        loader: 'babel-loader',
        options: {
          plugins: ['add-module-exports']
        }
      }
    ]
  },
  plugins: minifyPlugins
}
